﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Microsoft.Win32;
using System.IO;

namespace Suche
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        OpenFileDialog ofd = new OpenFileDialog();

        public MainWindow()
        {
            InitializeComponent();
            ofd.Filter = "Textdateien|*.txt";
        }

        private void FileSelect_Click(object sender, RoutedEventArgs e)
        {
            if(ofd.ShowDialog() == true)
            {
                buttonSuche.IsEnabled = true;
            }
            else
            {
                buttonSuche.IsEnabled = false;
            }
        }
       
        private void buttonSuche_Click(object sender, RoutedEventArgs e)
        {
            if(textBoxSuche.Text == "")
            {
                return;
            }

            StreamReader sr = null;
            try
            {
                sr = new StreamReader(ofd.FileName);

                const int längeDavor = 10;
                const int längeDanach = 10;
                int längePuffer = längeDavor + textBoxSuche.Text.Length + längeDanach + 100;
                char[] buffer = new char[längePuffer];

                string rest = "";
                int p = 0;
                while (!sr.EndOfStream)
                {
                    int n = sr.ReadBlock(buffer, 0, buffer.Length);
                    string s = rest + new string(buffer, 0, n);
                    bool ladeNach = false;
                    do
                    {
                        p = s.IndexOf(textBoxSuche.Text, p);
                        if (p >= 0) // fündig?
                        {
                            if(p + textBoxSuche.Text.Length + längeDanach <= s.Length)
                            {
                                //TODO: in ListBox merken
                                
                                p++;
                            }
                            else
                            {
                                if (sr.EndOfStream)
                                {
                                    //TODO: in ListBox merken
                                    
                                    p++;
                                }
                                else
                                {
                                    //im nächsten Durchgang behandeln
                                    int abzuschneiden = Math.Max(p - längeDavor, 0);
                                    rest = s.Substring(abzuschneiden);
                                    p -= abzuschneiden;
                                    ladeNach = true;
                                }
                            }
                        }
                        else
                        {
                            int abzuschneiden
                                = Math.Max(s.Length - längeDavor - textBoxSuche.Text.Length + 1, 0);
                            rest = s.Substring(abzuschneiden);
                            p = Math.Max(rest.Length - textBoxSuche.Text.Length + 1, 0);
                            ladeNach = true;
                        }
                    }
                    while(!ladeNach);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Fehler:\n" + ex.Message);
            }
            finally // kürzer: using
            {
                if (sr != null)
                {
                    sr.Close();
                }
            }
        }
    }
}
